require_relative './maintainer_core/writer'
require_relative './maintainer_core/setup'
require_relative './maintainer_core/cocoapodRunner'
require_relative './maintainer_core/gitRunner'
require_relative './maintainer_core/pipRunner'
require_relative './maintainer_core/updater'

module Maintainer
  class Runner
    class << self
      def setup
        Setup.setup!
      end
      def init
        Writer.welcome!
      #Setup.setup!
      end
      def pod(podname: nil)
        Writer.write(message: "Adding the pod: #{podname}")
        CocoapodRunner.add_pod(pod: podname)
      end
      def update_all!()
        Writer.write(message: "Updating All.....")
        Updater.update_all!
      end
      def podinit
        CocoapodRunner.create_podfile!
      end
      def uninstall_cocoapods
        CocoapodRunner.uninstall_cocoapods!
      end
      def install_cocoapods
        CocoapodRunner.install_cocoapods!
      end
      def install_git
        GitRunner.install_git!
      end
      def uninstall_git
        GitRunner.uninstall_git!
      end
      def pip(pkg: nil)
        Writer.write(message: "Adding the package: #{pkg}")
        PipRunner.install(pkg: pkg)
      end
      def install_pip()
        Writer.write(message: "Installing pip..")
        PipRunner.install_pip!
      end
    end
  end
end
