module Maintainer
    class GitRunner
        class << self 
            def uninstall_git!()
                CommandRunner.execute(command: Commands::Git::Uninstall, error: nil)
            end

            def install_git!()
                CommandRunner.execute(command: Commands::Git::Install, error: nil)
            end

            def is_git_installed!()
                version = CommandRunner.execute(command: Commands::Git::Version, error: nil)
                
                if  /^(\d+)(.\d+)?(.\d+)?$/ =~ version 
                    return true
                end
                puts "VERSION: #{version}"
                return false
            end
        end
    end
end