module Maintainer
    class Init
        class << self 

            MAINTAIN_FOLDER = 'maintain'
            MAINTAIN_FILE = 'Maintainfile'

            def setup!()
                self.create_folder!
                self.create_maintainfile!
            end
            def create_folder!(path = nil)
                maintainfolder_path = File.join(path || '.', MAINTAIN_FOLDER)

                # Sanity check
                return if File.directory?(maintainfolder_path)

                Writer.write(message: "\n\nYou already have a maintain folder...skipping creation") if File.exist?(maintainfolder_path)
                FileUtils.mkdir_p(maintainfolder_path)
                Writer.write(message: "\nCreated new folder '#{maintainfolder_path}'.")
            end
            def create_maintainfile!(path = nil)
                Writer.write(message: "Creating Maintainfile...")
                FileUtils.cd "./#{MAINTAIN_FOLDER}"
                FileUtils.touch "#{MAINTAIN_FILE}"
                Writer.write(message: "Maintainfile Created")
            end
        end
    end
end