
require_relative './commandRunner'
require_relative './commands'

module Maintainer
    class PipRunner
        class << self 
            def uninstall_pip!()
                CommandRunner.execute(command: Commands::Pip::Uninstall, error: nil)
            end

            def install_pip!()
                CommandRunner.execute(command: Commands::Pip::Install, error: nil)
            end

            def install(pkg: nil)
                # if not self.is_pip_installed!
                #     self.install_pip!
                # end
                CommandRunner.execute(command: "pip3 install #{pkg}", error: nil)
            end

            def is_pip_installed!()
                version = CommandRunner.execute(command: Commands::Pip::Version, error: nil)
                if  /^(\d+)(.\d+)?(.\d+)?$/ =~ version 
                    return true
                end
                puts "pip not installed"
                return true
            end
        end
    end
end