require 'colorize'

module Maintainer
    class Writer
        class << self 
            def welcome!()
                print "\nHi there!".green
                puts " Welcome to maintainer 🤘\n"
                puts "\nUnsure what this is? Read below!"
                puts "\nWith maintainer install/downloads and updates have never been easier"
                puts "Maintainer will keep track of all of your depenencies."
                puts "Updating those that need updating and keeping the dependency files out of the way"
                puts "\nMaintainer currently supports [cocoapods, git]\n\n"
            end
            def setup_guide!()
                puts "Starting setup guide...\n".green
            end
            def newline!()
                puts"\n"
            end
            def show_success(message: nil)
                puts "#{message}".green
            end
            def show_error(message: nil)
                puts "#{message}".red
            end
            def write(message: nil)
                puts message
            end
            def file_replace(filepath, regexp, *args, &block)
                content = File.read(filepath).gsub(regexp, *args, &block)
                File.open(filepath, 'wb') { |file| file.write(content) }
            end
            def file_write(filepath, text)
                filepath.puts "#{text}"
            end
        end
    end
end